// var toolbox = require("toolbox.js")

var game = {   
    forza4 : [],
    nColonne : 7,
    nLinee : 6,
    player1 : "x", // "x"
    player2 : "o", // "o"    

    init: function()
    {
        this.forza4 = toolbox.initTable(this.nLinee, this.nColonne, 0);
    },
    
    /**
     * Permette di mostrare una tabella in stile forza 4
     */
    mostraForza4: function()
    {
        const game = document.querySelector("#game");
        game.innerHTML = "";

        var content = "<table>"

        for(var i = 0; i < this.nLinee; i++)
        {
            content += "<tr>";
                for(var j = 0; j < this.nColonne; j++)
                {
                    content += "<td class='border text-center' style='width:100px;height:100px'>";      
                    if(this.forza4[i][j] === 0)
                    {
                        content += "";
                    }   
                    if(this.forza4[i][j] === 1)
                    {
                        content += "<img src='/assets/img/p1.png' class='bg-danger rounded-circle' style='max-width:90%;' />";
                    }   
                    if(this.forza4[i][j] === 2)
                    {
                        content += "<img src='/assets/img/p2.png' class='bg-success rounded-circle' style='max-width:90%;' />";
                    }                       
                    content += "</td>";
                }
            content += "</tr>";  
        }

        content += "<tr>"
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(1)'>Colonna 1</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(2)'>Colonna 2</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(3)'>Colonna 3</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(4)'>Colonna 4</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(5)'>Colonna 5</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(6)'>Colonna 6</button></td>";  
            content += "<td><button type='button' class='btn btn-secondary' onClick='play(7)'>Colonna 7</button></td>";  
        content += "</tr>" 

        content += "</table>";

        game.innerHTML = content;
    },

    /**
     * Funzione che permette di ottenere la prima linea VUOTA di una colonna
     * @param {*} colonna ritorna -1 se la colonna è piena
     * @returns 
     */
    ritornaLineaCasellaVuotaColonna: function(colonne)
    {
        for(var i = this.nLinee-1; i >= 0; i--)
        {
            if(this.verificaCasellaVuota(i, colonne)) return i;
        }
        return -1;
    },

    /**
     * Funzione che permette di otenere se una casella è vuota (ritorna true/false)
     * @param {*} linea 
     * @param {*} colonna 
     * @returns 
     */
    verificaCasellaVuota: function(linea, colonna)
    {
        return this.forza4[linea][colonna-1] === 0;
    },

    verificaFineDelGioco: function(player)
    {
        if(this.verificaLineaFineGioco(player) ||
            this.verificaColonnaFineGioco(player) || 
            this.verificaDiagonaleFineGioco(player)) 
        {
            return true;
        }
        return false;
    },

    /**
     * Funzione che permette di verificare se un giocatore ha vinto su una linea
     * @param {*} player 
     * @returns 
     */
    verificaLineaFineGioco: function(player)
    {
        for(var i = this.nLinee-1; i >= 0; i--)
        {
            for(var i=this.nLinee-1;i>=0; i--)
            {
                for (var j=0;j<this.nColonne-3;j++)
                {
                    if( this.forza4[i][j] === player &&
                        this.forza4[i][j+1] === player &&
                        this.forza4[i][j+2] === player &&
                        this.forza4[i][j+3] === player
                        )
                    {
                        return true;
                    }
                }
            }
        }
        return false;
    },

    /**
     * Funzione che permette di verificare se un giocatore ha vinto su una colonna
     * @param {*} player 
     * @returns 
     */
    verificaColonnaFineGioco: function(player)
    {
        for(var i = 0; i<this.nColonne;i++)
        {
            for(var j=this.nLinee-4;j>=0;j--)
            {
                if( this.forza4[j][i] === player &&
                    this.forza4[j+1][i] === player &&
                    this.forza4[j+2][i] === player &&
                    this.forza4[j+3][i] === player
                    ) return true;
            }
        }
    },

    /**
     * Funzione che permette di verificare se un giocatore ha vinto sulla diagonale
     * @param {*} player 
     * @returns 
     */
    verificaDiagonaleFineGioco: function(player)
    {
        for(var i=this.nLinee-1;i>=3; i--)
        {
            for (var j=0;j<this.nColonne;j++)
            {
                if( this.forza4[i][j] === player &&
                    this.forza4[i-1][j+1] === player &&
                    this.forza4[i-2][j+2] === player &&
                    this.forza4[i-3][j+3] === player
                    ) return true;
                if( this.forza4[i][j] === player &&
                    this.forza4[i-1][j-1] === player &&
                    this.forza4[i-2][j-2] === player &&
                    this.forza4[i-3][j-3] === player
                    ) return true;
            }
        }
        return false;
    },
    
    scegliereColonna: function()
    {
        return parseInt(toolbox.scriviStringa("Quale colonna scegli?"));
    },

    giocaColpo : function(player, lineaVuota, colonna)
    {
        this.forza4[lineaVuota][colonna-1] = player;
    }
}

// module.exports = game;